<?php

namespace Modules\Activity\Repositories\Contracts;

use Illuminate\Database\Eloquent\Collection;
use Modules\Activity\Entities\ActivityType;

interface ActivityTypeRepositoryInterface
{
    public function getAllPaginated(int $perPage = 10, string $search = '');

    public function getAllWithRelationsPaginated(
        int $perPage = 10,
        string $search = '',
        string $sortBy = 'name',
        string $sortOrder = 'asc'
    );

    public function getAllWithRelations(string $search = ''): Collection;

    public function create(array $data): ActivityType;

    public function findById(string $id): ?ActivityType;

    public function delete(string $id): bool;

    public function all(string $search = ''): Collection;
}
